<div align="left"><img src="https://raw.githubusercontent.com/grimmlab/ForeTiS/master/docs/image/Logo_ForeTiS_Text.png" height="80"/></div>

# ForeTiS: A Forecasting Time Series framework

[![Python 3.8](https://img.shields.io/badge/Python-3.8-3776AB)](https://www.python.org/downloads/release/python-388/)

ForeTiS is a Python framework that enables the rigorous training, comparison and analysis of time series forecasting for a variety of different models. 
ForeTiS includes multiple state-of-the-art prediction models or machine learning methods, respectively. 
These range from classical models, such as regularized linear regression over ensemble learners, e.g. XGBoost, to deep learning-based architectures, such as Multilayer Perceptron (MLP). 
To enable automatic hyperparameter optimization, we leverage state-of-the-art and efficient Bayesian optimization techniques. 
In addition, our framework is designed to allow an easy and straightforward integration and benchmarking of further prediction models.

## Documentation
For more information, installation guides, tutorials and much more, see our documentation: https://foretis.readthedocs.io/

## Contributors
This pipeline is developed and maintained by members of the [Bioinformatics lab](https://bit.cs.tum.de) lead by [Prof. Dr. Dominik Grimm](https://bit.cs.tum.de/team/dominik-grimm/):
- [Josef Eiglsperger, M.Sc.](https://bit.cs.tum.de/team/josef-eiglsperger/)
- [Florian Haselbeck, M.Sc.](https://bit.cs.tum.de/team/florian-haselbeck/)

## Citation
When using ForeTiS, please cite our publication:

**ForeTiS: A comprehensive time series forecasting framework in Python.** <br />
Josef Eiglsperger*, Florian Haselbeck* and Dominik G. Grimm. <br />
*Machine Learning with Applications, 2023.* [doi: 10.1016/j.mlwa.2023.100467](https://doi.org/10.1016/j.mlwa.2023.100467) <br />
**These authors have contributed equally to this work and share first authorship.* <br />
